package ruben.uoc.comedorescolar.activities;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Base64;
import android.util.Log;
import android.widget.ImageView;
import android.widget.TextView;

import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.GenericTypeIndicator;
import com.google.firebase.database.ValueEventListener;

import ruben.uoc.comedorescolar.R;
import ruben.uoc.comedorescolar.model.Alumno;

public class AlumnoPerfilActivity extends AppCompatActivity {

    private static final String TAG_FIREBASE_DATABASE = "Firebase Database";
    private FirebaseDatabase database;
    private DatabaseReference myRef;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_alumno_perfil);

        // Instancia de BBDD Firebase.
        database = FirebaseDatabase.getInstance();

        String usuario = (String) getIntent().getExtras().get("usuario");
        final String keyUsuario = usuario.replace(".","");

        // Recupero el centro al que pertenece el usuario
        myRef = database.getReference("usuarioCentro/" + keyUsuario + "/centro");
        myRef.addListenerForSingleValueEvent(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot) {
                String keyCentro = (String) dataSnapshot.getValue();

                // Recupero el alumno a partir del centro
                myRef = database.getReference("alumnos/" + keyCentro + "/" + keyUsuario);
                myRef.addListenerForSingleValueEvent(new ValueEventListener() {
                    @Override
                    public void onDataChange(DataSnapshot dataSnapshot) {
                        GenericTypeIndicator<Alumno> t = new GenericTypeIndicator<Alumno>(){};
                        Alumno alumno = dataSnapshot.getValue(t);

                        inicializarVistaDetalleAlumno(alumno);
                    }

                    @Override
                    public void onCancelled(DatabaseError error) {
                        Log.w(TAG_FIREBASE_DATABASE, "Error de lectura de base de datos .", error.toException());
                    }
                });
            }
            @Override
            public void onCancelled(DatabaseError error) {
                Log.w(TAG_FIREBASE_DATABASE, "Error de lectura de base de datos.", error.toException());
            }
        });

    }


    // Inicializamos los valores de la vista
    private void inicializarVistaDetalleAlumno(Alumno alumno){
        // Foto alumno
        String fotoB64 = alumno.getFotoAlumnoEncodedB64();
        byte[] fotoAlumnoByteArray = Base64.decode(fotoB64, Base64.DEFAULT);
        Bitmap fotoAlumnoBitmap = BitmapFactory.decodeByteArray(fotoAlumnoByteArray, 0, fotoAlumnoByteArray.length);


        ImageView imagenAlumno = findViewById(R.id.perfil_foto_alumno);
        imagenAlumno.setImageBitmap(fotoAlumnoBitmap);

        ((TextView)findViewById(R.id.perfil_nombre)).setText(alumno.getNombreAlumno());
        ((TextView)findViewById(R.id.perfil_apellido1)).setText(alumno.getApellido1Alumno());
        ((TextView)findViewById(R.id.perfil_apellido2)).setText(alumno.getApellido2Alumno());
        ((TextView)findViewById(R.id.perfil_dni)).setText(alumno.getDniAlumno());
    }
}
