package ruben.uoc.comedorescolar.activities;

import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Log;

import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.GenericTypeIndicator;
import com.google.firebase.database.ValueEventListener;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import ruben.uoc.comedorescolar.R;
import ruben.uoc.comedorescolar.adapters.RecyclerViewAdapterAlumno;
import ruben.uoc.comedorescolar.model.Alumno;
import ruben.uoc.comedorescolar.model.UsuarioRol;

public class ListadoAlumnosActivity extends AppCompatActivity {

    private static final String TAG_FIREBASE_DATABASE = "Firebase Database";

    private FirebaseDatabase database;
    private DatabaseReference myRef;

    private RecyclerView recyclerViewAlumno;
    private UsuarioRol usuarioRol;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_listado_alumnos);

        // Instancia de BBDD Firebase.
        database = FirebaseDatabase.getInstance();

        //RecyclerView
        recyclerViewAlumno = findViewById(R.id.recyclerView_alumno);

        usuarioRol = (UsuarioRol) getIntent().getSerializableExtra("usuarioRol");

        cargarDatos();
    }

    // Cargamos los datos de base de datos para inicializar la lista
    private void cargarDatos() {
        String keyCentro = usuarioRol.getUsuario().replace(".","");
        //myRef = database.getReference("alumnos/" + keyCentro);
        // TODO: Cambiar por el bueno
        myRef = database.getReference("alumnos/scorazon@gmailcom");

        // Se lee de base de datos (una sola vez)
        myRef.addListenerForSingleValueEvent(new ValueEventListener() {
            @Override
            public void onDataChange(DataSnapshot dataSnapshot) {
                GenericTypeIndicator<HashMap<String, Alumno>> t = new GenericTypeIndicator<HashMap<String, Alumno>>(){};
                HashMap<String,Alumno> alumnosHashMap = dataSnapshot.getValue(t);

                ArrayList<Alumno> alumnos = new ArrayList<>(alumnosHashMap.values());

                inicializarRecyclerView(alumnos);
            }

            @Override
            public void onCancelled(DatabaseError error) {
                Log.w(TAG_FIREBASE_DATABASE, "Error de lectura de base de datos recuperando los alumnos.", error.toException());
            }
        });
    }


    // Inicializamos el recyclerView
    private void inicializarRecyclerView(List<Alumno> alumnos) {
        // Creamos la lista de tipo RecyclerView, con su adaptador correspondiente
        RecyclerViewAdapterAlumno recyclerViewAdapterAlumno = new RecyclerViewAdapterAlumno(alumnos);
        recyclerViewAlumno.setAdapter(recyclerViewAdapterAlumno);

        // Asociamos un LayoutManager
        recyclerViewAlumno.setLayoutManager(new LinearLayoutManager(this));
    }


}
