package ruben.uoc.comedorescolar.activities;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;

import ruben.uoc.comedorescolar.R;
import ruben.uoc.comedorescolar.model.UsuarioRol;

public class MenuActivity extends AppCompatActivity implements View.OnClickListener{

    private UsuarioRol usuarioRol;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_menu);

        usuarioRol = (UsuarioRol) getIntent().getSerializableExtra("usuarioRol");

        if(usuarioRol.getRol().equals("centroEscolar")) {
            // Ocultamos el menú del alumno
            findViewById(R.id.menu_alumno).setVisibility(View.GONE);

            // Establecemos los listeners de los botones
            LinearLayout registrarComida = findViewById(R.id.registrar_comida);
            registrarComida.setOnClickListener(this);

            LinearLayout listarAlumnos = findViewById(R.id.listar_alumnos);
            listarAlumnos.setOnClickListener(this);

            LinearLayout verCalendarioAlimenticio = findViewById(R.id.ver_calendario_centro);
            verCalendarioAlimenticio.setOnClickListener(this);
        }else {
            // Ocultamos el menú del centro escolar
            findViewById(R.id.menu_centro).setVisibility(View.GONE);

            // Establecemos los listeners de los botones
            LinearLayout verPerfil = findViewById(R.id.perfil_alumno);
            verPerfil.setOnClickListener(this);

            LinearLayout verCalendarioAlimenticio = findViewById(R.id.ver_calendario_alumno);
            verCalendarioAlimenticio.setOnClickListener(this);
        }
    }


    // La opciones de menú nos lleva cada una a una nueva activity
    @Override
    public void onClick(View view) {
        int i = view.getId();
        if (i == R.id.registrar_comida) {
            Intent intent = new Intent(this, RegistroMenuActivity.class);
            intent.putExtra("usuario", usuarioRol.getUsuario());
            startActivity(intent);
        }
        else if(i == R.id.listar_alumnos){
            Intent intent = new Intent(this, ListadoAlumnosActivity.class);
            intent.putExtra("usuarioRol", usuarioRol);
            startActivity(intent);
        }
        else if(i == R.id.ver_calendario_centro){
            Intent intent = new Intent(this, CalendarioActivity.class);
            intent.putExtra("usuarioRol", usuarioRol);
            startActivity(intent);
        }
        else if(i == R.id.perfil_alumno){
            Intent intent = new Intent(this, AlumnoPerfilActivity.class);
            intent.putExtra("usuario", usuarioRol.getUsuario());
            startActivity(intent);
        }
        else if(i == R.id.ver_calendario_alumno){
            Intent intent = new Intent(this, CalendarioActivity.class);
            intent.putExtra("usuarioRol", usuarioRol);
            startActivity(intent);
        }
    }
}
