package ruben.uoc.comedorescolar.adapters;


import android.content.Context;
import android.graphics.Color;
import android.support.annotation.NonNull;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import java.util.List;

import ruben.uoc.comedorescolar.model.CentroEscolar;

public class SpinnerAdapterCentro extends ArrayAdapter<CentroEscolar> {

    private Context context;
    private List<CentroEscolar> centrosEscolares;

    public SpinnerAdapterCentro(@NonNull Context context, int textViewResourceId, @NonNull List<CentroEscolar> centros) {
        super(context, textViewResourceId, centros);

        this.context = context;
        this.centrosEscolares = centros;
    }

    @Override
    public int getCount(){
        return centrosEscolares.size();
    }

    @Override
    public CentroEscolar getItem(int position){
        return centrosEscolares.get(position);
    }

    @Override
    public long getItemId(int position){
        return position;
    }


    // Personalizamos el elemento seleccionado
    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        TextView label = new TextView(context);
        label.setTextColor(Color.WHITE);
        label.setText(centrosEscolares.get(position).getNombreCentro());
        return label;
    }


    // Personalizamos el desplegable
    @Override
    public View getDropDownView(int position, View convertView, ViewGroup parent) {
        TextView label = new TextView(context);
        label.setTextColor(Color.BLUE);
        label.setText(centrosEscolares.get(position).getNombreCentro());
        return label;
    }

}
